let sessionNumber = 12;
require('geckodriver');
// Generated by Selenium IDE
const { Builder, By, Key, until } = require('selenium-webdriver')
const assert = require('assert');
const firefox = require('selenium-webdriver/firefox');
const { performance } = require('perf_hooks');
const fs = require('fs');
const path = require('path');
const chai = require('chai');
const expect = chai.expect;

const data = fs.readFileSync('./test/grading.json');
const jsonData = JSON.parse(data);

if(jsonData.gradedTest.s12 === false){

	try {


    if (!fs.existsSync('./sessions/frontend/s12/activity/index.html')) {
			throw new Error('File not found');
		  }
      //Automated Grading Integration
      // Variable to store passing unit test scores for the session
      let passingTests = 0;
      // Variable to store total number of session unit tests
      let totalTests = 0;


      function parsePixels(value) {
          return parseFloat(value.replace('px', ''));
        }

      describe('s12', function() {

        this.timeout(30000);
        const timeout = 10000;
        let driver;
        let vars;

        let internalCssTestPassed = false;

        let startTime;
        let errors = [];
        before(async function() {
          startTime = performance.now();
          // Any setup code you need to run before the tests start
          driver = await new Builder().forBrowser('firefox').setFirefoxOptions(options).build()
        });
        
        const options = new firefox.Options();
        options.headless();
  
        options.setPreference('browser.download.manager.showWhenStarting', false);
        options.setPreference('browser.download.manager.useWindow', false);
  
        beforeEach(async function() {

          totalTests += 1;
          vars = {}
        })
  
        afterEach(function(){
  
          if(this.currentTest.state === "passed"){
            passingTests += 1;
          }
  
          process.removeAllListeners(); 

          if (this.currentTest.state === 'failed') {
            errors.push({
                test: this.currentTest.title,
                feedback: this.currentTest.err.message
            });
        }
  
        })

        it('Check if the page has bootstrap version 4.6', async function() {

            const filePath = path.join(__dirname, '..','sessions','frontend','s12','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);

            const bootstrapVersion = await driver.findElement(By.css("link")).getAttribute("href");
            expect(bootstrapVersion).to.include("4.6","bootstrap version should be 4.6");

        });

        it('Check if the projects div is container-fluid and has text-center and padding', async function() {

            const filePath = path.join(__dirname, '..','sessions','frontend','s12','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);

            const projectsDiv = await driver.findElement(By.id('projects'));

            const classes = await projectsDiv.getAttribute('class');
            expect(classes).to.contain('container-fluid',"div projects is not container-fluid");
        
            const textAlignment = await projectsDiv.getAttribute('class');
            expect(textAlignment).to.contain('text-center',"div projects does not have text center");
        
            const paddingClasses = await projectsDiv.getAttribute('class');
            expect(paddingClasses).to.match(/p-[12345]/,"div projects does not have instructed padding");

        });

        it('Check if the react and api divs are bootstrap rows and has margins.', async function() {

            const filePath = path.join(__dirname, '..','sessions','frontend','s12','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);

            const reactDiv = await driver.findElement(By.css('#react'));
            const apiDiv = await driver.findElement(By.css('#api'));

            const reactClasses = await reactDiv.getAttribute('class');
            const apiClasses = await apiDiv.getAttribute('class');
        
            expect(reactClasses).to.contain('row',"react div does not have row");
            expect(apiClasses).to.contain('row',"api div does not have row");
        
            const reactMarginTop = await reactDiv.getCssValue('margin-top').then(parsePixels);
            const reactMarginBottom = await reactDiv.getCssValue('margin-bottom').then(parsePixels);
            const apiMarginTop = await apiDiv.getCssValue('margin-top').then(parsePixels);
            const apiMarginBottom = await apiDiv.getCssValue('margin-bottom').then(parsePixels);
        
        
            expect(reactMarginTop).to.be.at.least(1,"react no margin top.");
            expect(reactMarginBottom).to.be.at.least(1,"react no margin bottom.");
            expect(apiMarginTop).to.be.at.least(1,"api no margin top.");
            expect(apiMarginBottom).to.be.at.least(1,"api no margin bottom.");

        });

        it('Check if the react row columns have col-12 and col-md-6', async function() {

            const filePath = path.join(__dirname, '..','sessions','frontend','s12','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);

            const reactCols = await driver.findElements(By.css('#react > div'));

            for (let i = 0; i < reactCols.length; i++) {
                const classCol = await reactCols[i].getAttribute("class");
                expect(classCol).to.include("col-md-6","react column does not have col-md-6")
              }

              const apiCols = await driver.findElements(By.css('#api > div'));

              for (let i = 0; i < apiCols.length; i++) {
                  const classCol = await apiCols[i].getAttribute("class");
                  expect(classCol).to.include("col-md-6","api column does not have col-md-6")
                }

        });

        it('Check react row columns orders', async function() {

            const filePath = path.join(__dirname, '..','sessions','frontend','s12','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);

            const reactCols = await driver.findElements(By.css('#react > div'));

            const classCol1 = await reactCols[0].getAttribute("class");
            expect(classCol1).to.include("order-2","react column does not contain order-2 or order-md-2").include("order-md-2")

            const classCol2 = await reactCols[1].getAttribute("class");
            expect(classCol2).to.include("order-1","react column does not contain order-1")
            expect(classCol2).to.include("order-md-1","react column does not contain order-md-1")
        });

        it('Check api row columns orders', async function() {

            const filePath = path.join(__dirname, '..','sessions','frontend','s12','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);

            const apiCols = await driver.findElements(By.css('#api > div'));

            const classCol1 = await apiCols[0].getAttribute("class");
            expect(classCol1).to.include("order-2","api column 1 does not contain order-2").include("order-md-1","api column does not contain order-md-1")

            const classCol2 = await apiCols[1].getAttribute("class");
            expect(classCol2).to.include("order-1","api column 2 does not contain order-1").include("order-md-2","api column does not contain order-md-2")
        });

        it('Check other-project div is a row', async function() {

            const filePath = path.join(__dirname, '..','sessions','frontend','s12','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);

            const otherProj = await driver.findElement(By.css('#other-projects'));

            const otherProjRow = await otherProj.getAttribute("class");
            expect(otherProjRow).to.include("row","otherProj div is a row")

        });

        it('Check if the other-projects row columns have col-12 and col-md-4', async function() {

            const filePath = path.join(__dirname, '..','sessions','frontend','s12','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);

            const projCols = await driver.findElements(By.css('#other-projects > div'));

            for (let i = 0; i < projCols.length; i++) {
                const projCol = await projCols[i].getAttribute("class");
                expect(projCol).to.include("col-md-4","proj column does not have col-md-4")
            }

        });

        it('Check if all img elements has img-fluid', async function() {

          const filePath = path.join(__dirname, '..','sessions','frontend','s12','activity','index.html');
          const url = `file://${filePath}`;
          await driver.get(url);

          const img = await driver.findElements(By.css('img'));

          for(let i = 0; i < img.length; i++){

            const imgfluid = await img[i].getAttribute("class");
            expect(imgfluid).to.include("img-fluid","an img element does not have img-fluid");

          }

      });

    
        after(async function () {

          
          const endTime = performance.now();
          const totalTime = (endTime - startTime) / 1000; // Convert to seconds
          console.log(`Total time taken: ${totalTime} seconds`);
          
          
          global.gradesObject["s12"] = {
            grade: `${passingTests/totalTests >= 0.75 ? "P" : "F"}`,
            score: `${passingTests}/${totalTests}`,
            feedback: errors.length ? errors : "No Errors"
          }
          
          jsonData.gradedTest.s12 = true;
          await fs.writeFileSync('./test/grading.json', JSON.stringify(jsonData,null,4));
          await driver.quit(); 

        });

      })	

	
    } catch (err) {
      if(err.code === "MODULE_NOT_FOUND" || err.message === "File not found"){
        console.error(`s${sessionNumber} cannot be found. Check activity folder.`);
      } else {
        console.log(err)
      }
    }
} else {
	console.log("s12 - Tested");
}